% P14_3
% Antreneaza un filtru Wiener FIR cu seria de timp a indicelui Dow Jones intre 4 apr.2010 - 4 apr.2011
% si apoi foloseste filtrul pentru a prezice evolutia pe intervalul 5 apr.2011 - 3 mai 2011

clear all
close all

% Incarca seriile de timp
% load data1   --->
% load data2   --->
% load dji     ---> indicele Dow Jones intre 4 apr.2010 - 4.apr.2011 si 5 apr.2010 - 3 mai 2011
% Fisierele contin:
% data      = datele de antrenare
% data_cont = datele pentru verificarea predictiei
load data1;

% (Preprocesare) Scade valoarea medie pentru a aduce semnalele la valori mici, centrate in jurul lui 0
%med = mean(data);
%data  = data  - med;
%data_cont = data_cont - med;

% Predictie inainte cu un esantion (D = 1)
% data = secventa de antrenare
% intrare:      x[n] = data[n]
% semnal dorit: s[n] = data[n+1]
L = numel(data);
M = 50;
x = data(1:L-1);
d = data(2:L);
[h,mmse] = wienerfir(x,d,M);  % gasire coef. Wiener FIR

% Vizualizare semnal dorit (d) si semnal obtinut la iesirea filtrului (y)
y = filter(h,1,x);
figure
plot([d',y'])
legend('Dorit','Obtinut cu Wiener FIR');

% Calcul eroare
e1 = sum((d - y).^2) / (L-1);           % eroarea semnalului obtinut cu Wiener FIR         
e2 = sum((d - data(1:L-1)).^2) / (L-1);  % eroarea semnalului data[n-1]
disp(['Eroarea patratica medie obtinuta cu Wiener FIR este: ' num2str(e1)]);

% Predictie cu filtrul obtinut mai sus pentru urmatoarele 20 de esantioane
L2 = numel(data_cont);
data_pred = data;
for i=1:L2
    % Esantion curent = suma ultimelor M esantioane cu coeficientii h_i
    data_pred(L+i) = sum( data_pred(L+i-1:-1:L+i-M) .* h' );
end

% Afisare: indice real (data_cont) vs. prezis (data_pred)
figure
plot([[data data_cont]', data_pred'])
legend('Real', 'Prezis');