%Program p14_1
clc

% Generare semnal initial
L = 1000;
sigmav = 0.8;
v = randn(1,L)*sigmav;

% Laborator PSS: Fitre Wiener pentru filtrare si predictie
% P14_1: Filtre Wiener FIR

% Filtrare prin filtru IIR cu un pol a
a = 0.6;
s = filter(1,[1 -a],v);    % -->  Semnalul s initial

% Peste semnalul s rezultat se suprapune un zgomot alb cu sigma = 1
sigmaw = 1;
x = s + sigmaw*randn(1,L); % -->  x = s + zgomot

% Filtrare cu filtrul FIR dedus teoretic pentru M = 2
s0 = filter([0.451 0.165],1,x);
e0 = sum((s0-s).^2)/L;
disp(['Eroarea patratica medie obtinuta cu filtrul H(z) = 0.451 + 0.165z^-1 este: ' num2str(e0)]);

% Calculare filtru Wiener FIR cu wienerfir() si filtrare cu acesta
M=80;
[h,mmse]=wienerfir(x,s,M);

s1=filter(h,1,x);
e1=sum((s1-s).^2)/L;
disp(['Eroarea patratica medie obtinuta cu filtrul FIR calculat cu ec. Wiener-Hopf este: ' num2str(e1)]);

% Filtrare cu un filtru FIR oarecare
s2=filter([0.2, 0.16],1,x);
e2=sum((s2-s).^2)/L;
disp(['Eroarea patratica medie obtinuta cu un filtru FIR oarecare este: ' num2str(e2)]);

plot([s' s0' s1' s2'])
legend('Semnalul original s','Semnalul s0','Semnalul s1','Semnalul s2');
